/**
 * This is a multi-threaded version of the first program. It runs the two
 * checks for primality in separate threads (distinct from the main thread).
 */
public class B_PrimeCheck_Thread {
  public static void main(String[] args) {
    System.out.println("starting...");

    PrimeCheckR check1 = new PrimeCheckR(93877037L);
    Thread thread1 = new Thread(check1);
    thread1.start();

    PrimeCheckR check2 = new PrimeCheckR(93877039L);
    Thread thread2 = new Thread(check2);
    thread2.start();

    System.out.println("done!");
  }
}

/**
 * An object that can check a single number for primality.
 */
class PrimeCheckR implements Runnable {
  private long num;

  /**
   * Create a new prime checker for a particular number.
   */
  public PrimeCheckR(long n) {
    this.num = n;
  }

  /**
   * Run the primality check and print the result to System.out.
   */
  public void run() {
    // Try every divisor from 2 to num - 1.
    for (long i = 2; i < num; ++i) {
      // If num is divisible by this number, it's not prime.
      if (num % i == 0) {
        System.out.println(num + " is composite: divisible by " + i);
        return;
      }
    }

    // We didn't return yet, so the number is prime.
    System.out.println(num + " is prime!");
  }
}
